/*
 * PIAVE - PIAVE Is A Video Editor
 *
 * Copyright (C) 2002 Rolf Dubitzky, rolf@dubitzky.de
 *
 */

/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


/**
 * \file ffstream.hh implements in and out streams
 *       using libav and libavcodec from ffmpeg project
 */


#if ! defined( FFMPEG_HH )
#define FFMPEG_HH

// stdc++
#include <string>

// PIAVE
#include "libpiave/piave_base.hh"
#include "libpiave/avstream.hh"

// ffmpeg
#if ! defined( LIBAV_HEADERS_HH )
#define LIBAV_HEADERS_HH
#undef MIN
#undef MAX
#undef ABS
extern "C" {
#include "avformat.h"
#include "avcodec.h"
}
#endif


namespace PIAVE {

#define FFMPEG_INBUF_SIZE 4096


    /**
     *   \class FFMpeg  is a static class and takes care of
     *   global initializations for ffmpeg
     */

    struct FFMpeg {
        static void init();
        static bool is_initialized;
    };

}


#endif
